#ifndef _AxpAd02_H_
#define _AxpAd02_H_

#ifdef __cplusplus
extern "C" {
#endif

#define AD02_SOCKET_AUTO			((WORD)~0U)
#define AD02_MAX_SOCKETS			4
#define AD02_NUM_CHANNELS			8
//-------------------------------------------------------------------
// dW
//-------------------------------------------------------------------
#define	AD02_VR_S10V				0	// +-10V range
#define	AD02_VR_S5V					1	// +- 5V range
//-------------------------------------------------------------------
// gK
//-------------------------------------------------------------------
#define	AD02_TS_INTERNAL			0	// gKgp
#define	AD02_TS_EXTERNAL			1	// OgKgp
//-------------------------------------------------------------------
// TvO
//-------------------------------------------------------------------
#define	AD02_SM_ONESHOT				0	// Vbg
#define	AD02_SM_CONTINUOUS			1	// ATvO
//-------------------------------------------------------------------
// TvOXe[^X̃rbg}XN
//-------------------------------------------------------------------
#define	AD02_BMSST_BUSY				(1 <<  0)	// Busy
#define	AD02_BMSST_EOC				(1 <<  1)	// Not busy
#define	AD02_BMSST_HALF_FULL		(1 <<  2)	// Ring buffer half full
#define	AD02_BMSST_OVERFLOW			(1 <<  3)	// Ring buffer overflow
#define	AD02_BMSST_OVERRUN			(1 <<  4)	// FIFO overrun
//-------------------------------------------------------------------
// AvP[Vɑ郁bZ[W
// ̒l uWMBase𑫂l𑗏o܂
//-------------------------------------------------------------------
#define	AD02_WM_OFS_CARD_REMOVAL	0
#define	AD02_WM_OFS_EOC				1
#define	AD02_WM_OFS_HALF_FULL		2
#define	AD02_WM_OFS_OVERFLOW		3
#define	AD02_WM_OFS_OVERRUN			4
#define	AD02_WM_OFS_EXIN			5
//-------------------------------------------------------------------
// 샂[h\
//-------------------------------------------------------------------
typedef	struct {
	DWORD	dwVoltageRange;		// dW
	DWORD	dwChFirst;			// Jn`l
	DWORD	dwChLast;			// ŏI`l
	DWORD	dwTimer;			// ^C}
	DWORD	dwTrigSource;		// gK\[X
	DWORD	dwSampleMode;		// TvO[h
	DWORD	cwBuffer;			// obt@TCY
} AD02MODE,*PCAD02M;
//-------------------------------------------------------------------
// \[X\
//-------------------------------------------------------------------
#define AD02_MAX_MEM		9
#define AD02_MAX_IO			20
#define AD02_MAX_IRQ		7
#define AD02_MAX_DMA		7

typedef struct _AD02_RESOURCE {
    DWORD   dwNumMemWindows;						// Not used
    DWORD   dwMemBase       [AD02_MAX_MEM];			// Not used
    DWORD   dwMemLength     [AD02_MAX_MEM];			// Not used
    DWORD   dwMemAttrib     [AD02_MAX_MEM];			// Not used
    DWORD   dwNumIOPorts;							// Num IO ports
    DWORD   dwIOPortBase    [AD02_MAX_IO];			// I/O port base
    DWORD   dwIOPortLength  [AD02_MAX_IO];			// I/O port length
    DWORD   dwNumIRQs;								// NumIRQs
    DWORD   dwIRQRegisters  [AD02_MAX_IRQ];			// IRQ Registers
    DWORD   dwIRQAttrib     [AD02_MAX_IRQ];			// IRQ Attrib
	DWORD	dwNumDMAs;								// Not used
    DWORD   dwDMALst        [AD02_MAX_DMA];			// Not used
    DWORD   dwDMAAttrib     [AD02_MAX_DMA];			// Not used
    DWORD   dwReserved1     [3];					// Not used
} AD02_RESOURCE, *PAD02R;
//-------------------------------------------------------------------
// G[R[h
//-------------------------------------------------------------------
#define	AD02_SUCCESS				0	// ُȂiIj
#define	AD02_ERR_SYSTEM				1	// ɃhCo[hĂȂ\܂
#define	AD02_ERR_NO_DEVICE			2	// gp\ȃfoCX܂
#define	AD02_ERR_NOT_CREATED		3	// w̃foCX͎gp錾Ă܂
#define	AD02_ERR_IN_USE				4	// w̃foCX͑̃vZXŎgpł
#define	AD02_ERR_INVALID_SOCKET		5	// Ș_\Pbgԍł
#define	AD02_ERR_RESOURCE			6	// \[XG[
#define	AD02_ERR_INVALID_ARGUMENT	7	// sȈw肵܂
#define	AD02_ERR_VOLTAGE_RANGE		8	// sȓdlw肵܂
#define	AD02_ERR_CHANNEL			9	// sȃ`lw肵܂
#define	AD02_ERR_TIMER				10	// sȃ^C}w肵܂
#define	AD02_ERR_TRIG_SOURCE		11	// sȃgKw肵܂
#define	AD02_ERR_SAMPLE_MODE		12	// sȃ[hw肵܂
#define	AD02_ERR_NOT_ENOUGH_MEM		13	// w肳ꂽobt@mۂł܂ł
#define	AD02_ERR_NO_DATA			14	// f[^v܂
#define	AD02_ERR_NO_DLL				15	// ckkɃ[h܂ł
#define AD02_ERR_NO_SETMODE			20	// [hݒ肳Ă܂ł
#define AD02_ERR_BUSY				21	// TvO쒆ł

#ifdef __cplusplus
}
#endif
#endif
