/*****************************************************************************
 *	axpad02s.c
 *
 *	AXP-AD02
 *	Copyright ADTEK SYSTEM SCIENCE Co.,Ltd.
 *
 *	Date Sep.2000
 *
 *	̃\[Xɂ̓bp[֐̎gpႪLqĂ܂B
 *
 *
 *    Ad02wSingleSampling gpǉ
 *****************************************************************************/
#define	STRICT
#include <windows.h>
#include <tchar.h>
#include "axpad02w.h"

const TCHAR szTitle[] = _T("Sample");
const TCHAR szAD02[] = _T("AXP-AD02");
static void ResultMessage(LPCTSTR lpszbuf);
static void ErrorMessage(WORD wLogSocket);

int WINAPI WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance,
												LPSTR lpCmdLine, int nCmdShow)
{
	TCHAR szbuf[1024],szTemp[64];
	DWORD dwDLLVer, dwDrvVer;
	BOOL  bResult;						// 
	WORD  wLogSocket;					// foCXi[
	AD02_RESOURCE ri;					// \[X
	AD02MODE md;						// 샂[h
	DWORD dwNumData, dwStatus;
	PWORD pwBuffer;
	DWORD i;
	BYTE  bValue;
	DWORD dwCh;
	DWORD dwVRange;
	WORD  wSingleData;

//-----------------	 axpad02.dll ̎gp錾 --------------------------------
	if ( Ad02wDllOpen() == FALSE ) {
		ErrorMessage(AD02_SOCKET_AUTO);
		return 1;						// axpad02.dll ̃[hɎs܂
	}
//--------------------	o[Wԍ\	----------------------------------
	// AXP-AD02 DLL,Driver̃o[Wԍ擾
	if (Ad02wGetVersion(&dwDLLVer, &dwDrvVer) == FALSE) {
		ErrorMessage(AD02_SOCKET_AUTO);
		return 1;
	}
	wsprintf(szbuf, _T("GetVersion\n") _T("DLL Version: %08lxh\n")
							_T("Drv Version: %08lxh"), dwDLLVer, dwDrvVer );
	ResultMessage(szbuf);
//-----------------------  AXP-AD02̎gp錾	 -----------------------------
	wLogSocket = AD02_SOCKET_AUTO;			// gp̃foCXT܂B
	bResult = Ad02wCreate( &wLogSocket, NULL, 0, NULL );
				// wLogSlot -- ꍇA̎̃foCXi[܂B
	if (bResult == FALSE) {
		ErrorMessage(AD02_SOCKET_AUTO);
		return 1;
	}
	wsprintf(szbuf, _T("AXP-AD02 Created\n\n") _T("LogSocket: %2d\n"), wLogSocket);
	ResultMessage(szbuf);
//-------------------------  \[X擾  -----------------------------
	if (Ad02wGetResource(wLogSocket, &ri) == FALSE) {
		ErrorMessage(wLogSocket);
		return 1;
	}
	wsprintf(szbuf, _T("Card Name: %s\n")
					_T("IO Address : %04xh-%04xh\n")
					_T("IRQ        : %d\n") ,
					szAD02,
					ri.dwIOPortBase[0],ri.dwIOPortBase[0] + ri.dwIOPortLength[0] - 1,
					ri.dwIRQRegisters[0] );
	ResultMessage(szbuf);
//------------------------  TvO[h̐ݒ  --------------------------
	md.cwBuffer			= 256;				// obt@TCYi[hPʁj
	md.dwChFirst		= 0;				// TvOJn`li0 ` 7j
	md.dwChLast			= 0;				// TvOŏI`li0 ` 7j
	md.dwSampleMode		= AD02_SM_ONESHOT;	// TvO[h
	md.dwTimer			= 50;				// ^C}li1`255j
	md.dwTrigSource		= AD02_TS_INTERNAL;	// gK\[X
	md.dwVoltageRange	= AD02_VR_S10V;		// ͓dW

	if ( Ad02wSetMode( wLogSocket, &md ) == FALSE ) {
		ErrorMessage(wLogSocket);
		return 1;
	}
	wsprintf( szbuf,
		_T("AXP-AD02 Sampling mode\n")
		_T("TvOJn`l = %d\n")
		_T("TvOI`l = %d\n")
		_T("obt@TCY = %d\n")
		_T("^C}l = %d\n")
		_T("샂[h = %d"),
		md.dwChFirst,
		md.dwChLast,
		md.cwBuffer,
		md.dwTimer,
		md.dwSampleMode );
	ResultMessage(szbuf);
//----------------------------  TvOJn  ------------------------------
	if ( Ad02wStartSampling( wLogSocket ) == FALSE ) {
		ErrorMessage(wLogSocket);
		return 1;
	}
	ResultMessage("AXP-AD02 Sampling started");
//-----------------------  TvOXe[^X擾  -------------------------
	if ( Ad02wGetSamplingStatus( wLogSocket, &dwNumData, &dwStatus ) == FALSE ) {
		ErrorMessage(wLogSocket);
		return 1;
	}
	wsprintf( szbuf,
		_T("AXP-AD02 Sampling status\n")
		_T("f[^ = %d\n")
		_T("Xe[^X = %xH" ),
		dwNumData, dwStatus );
	ResultMessage(szbuf);
//--------------------------  TvOf[^擾  -------------------------
	if ( dwNumData > 0 ) {
		pwBuffer = (PWORD)malloc( dwNumData * sizeof(WORD) );
		if ( pwBuffer == NULL ) {
			ResultMessage( "obt@mۂł܂ł" );
			return 1;
		}
		if ( Ad02wGetData( wLogSocket, pwBuffer, dwNumData ) == FALSE ) {
			free(pwBuffer);
			ErrorMessage(wLogSocket);
			return 1;
		}
		wsprintf( szbuf,"TvOf[^\n");
		// f[^XXҏW甲悤ɂ
		if ( dwNumData > 99 ) dwNumData = 99;
		for ( i = 0 ; i < dwNumData ; i++ ) {
			wsprintf( szTemp, _T("%02d:%lxh  "), i, pwBuffer[i]);
			strcat(szbuf, szTemp);
			if ((i + 1) % 4 == 0)	// 4 Ŋ؂
				strcat(szbuf, _T("\n"));
		}
		ResultMessage(szbuf);
		free(pwBuffer);
	}
//----------------------------  TvO~  ------------------------------
	if ( Ad02wStopSampling( wLogSocket ) == FALSE ) {
		ErrorMessage(wLogSocket);
		return 1;
	}
	ResultMessage("AXP-AD02 Sampling stop");

//------------------------  VOTvOs  --------------------------

	dwCh = 0;
	dwVRange = AD02_VR_S10V;

	if ( Ad02wSingleSampling( wLogSocket,dwCh,dwVRange,&wSingleData) == FALSE ) {
		ErrorMessage(wLogSocket);
		return 1;
	}

	wsprintf( szbuf,
		_T("VOTvO\n")
		_T("`l %d : %X"), dwCh, wSingleData );
	ResultMessage(szbuf);


//--------------------------  ėp͂̒l擾  ------------------------------
	if ( Ad02wInPort( wLogSocket, &bValue ) == FALSE ) {
		ErrorMessage(wLogSocket);
		return 1;
	}
	wsprintf( szbuf, "ėp͒l : %Xh", bValue );
	ResultMessage(szbuf);

//--------------------------  ėpo͂ɒlo  ------------------------------
	bValue = 0x0A;
	if ( Ad02wOutPort( wLogSocket, bValue ) == FALSE ) {
		ErrorMessage(wLogSocket);
		return 1;
	}
	ResultMessage( "ėpo̓|[g 0x0A o͂܂" );

//-----------------------------  foCXJ  -------------------------------
	if ( Ad02wClose( wLogSocket ) == FALSE ) {
		ErrorMessage(wLogSocket);
		return 1;
	}
	ResultMessage("AXP-AD02 Close");
//----------------------  axpad02.dll ̎gpJ  ----------------------------
	if (Ad02wDllClose() == FALSE) {
		MessageBox(NULL, _T("DLL ̃A[hɎs܂B"),
										szTitle, MB_OK | MB_ICONSTOP);
		return 1;			// axpad02.dll ̃A[hɎs܂B
	}

	return 0;
}
// ʂ\
static void ResultMessage(LPCTSTR lpszbuf)
{
	MessageBox(NULL, lpszbuf, szTitle, MB_OK | MB_ICONINFORMATION);
}

// G[bZ[W\
static void ErrorMessage(WORD wLogSocket)
{
	DWORD dwRes = Ad02wGetLastError(wLogSocket);
	TCHAR szbuf[50];

	switch (dwRes) {
		case AD02_ERR_SYSTEM:
			wsprintf(szbuf, _T("System error\n\n")
							_T("Error code: %08lxh"), GetLastError());
			break;

		case AD02_ERR_WRAPDLL:
			wsprintf(szbuf, _T("DLL Load error"));
			break;

		default:
			wsprintf(szbuf, _T("AXP-AD02 error\n\n")
							_T("Error code: %08lxh"), dwRes);
			break;
	}
	MessageBox(NULL, szbuf, szTitle, MB_OK | MB_ICONSTOP);
}
